"""
A test script for anglitime.

While we have not started the code for anglitime, we do already
have some tests for it.  We always write the tests first.

Author: Walker M. White
Date:   September 20, 2020
"""
import introcs
import angl


def test_anglitime():
    """
    Test procedure for anglitime(s)
    """
    print("Testing function anglitime")
    # Plural ones digit hour, plural ones digit minute
    result = angl.anglitime('0:00')
    introcs.assert_equals('zero hours, zero minutes',result)

    # Singular ones digit hour, plural ones digit minute
    result = angl.anglitime('1:03')
    introcs.assert_equals('one hour, three minutes',result)

    # Teens hour value, plural ones digit minute
    result = angl.anglitime('12:04')
    introcs.assert_equals('twelve hours, four minutes',result)

    # Two digit hour with no ones digit, plural ones digit minute
    result = angl.anglitime('70:00')
    introcs.assert_equals('seventy hours, zero minutes',result)

    # Proper two digit hour, plural ones digit minute
    result = angl.anglitime('43:07')
    introcs.assert_equals('forty three hours, seven minutes',result)

    # Plural ones digit hour, singular ones digit minute
    result = angl.anglitime('2:01')
    introcs.assert_equals('two hours, one minute',result)

    # Singular ones digit hour, singular ones digit minute
    result = angl.anglitime('1:01')
    introcs.assert_equals('one hour, one minute',result)

    # Teens hour value, singular ones digit minute
    result = angl.anglitime('10:01')
    introcs.assert_equals('ten hours, one minute',result)

    # Two digit hour with no ones digit, singular ones digit minute
    result = angl.anglitime('30:01')
    introcs.assert_equals('thirty hours, one minute',result)

    # Proper two digit hour, singular ones digit minute
    result = angl.anglitime('76:01')
    introcs.assert_equals('seventy six hours, one minute',result)

    # Plural ones digit hour, teens minute value
    result = angl.anglitime('4:15')
    introcs.assert_equals('four hours, fifteen minutes',result)

    # Singular ones digit hour, teens minute value
    result = angl.anglitime('1:17')
    introcs.assert_equals('one hour, seventeen minutes',result)

    # Teens hour value, teens minute value
    result = angl.anglitime('13:11')
    introcs.assert_equals('thirteen hours, eleven minutes',result)

    # Two digit hour with no ones digit, teens minute value
    result = angl.anglitime('80:10')
    introcs.assert_equals('eighty hours, ten minutes',result)

    # Proper two digit hour, teens minute value
    result = angl.anglitime('54:19')
    introcs.assert_equals('fifty four hours, nineteen minutes',result)

    # Plural ones digit hour, two digit minute with no ones digit
    result = angl.anglitime('5:30')
    introcs.assert_equals('five hours, thirty minutes',result)

    # Singular ones digit hour, two digit minute with no ones digit
    result = angl.anglitime('1:40')
    introcs.assert_equals('one hour, forty minutes',result)

    # Teens hour value, two digit minute with no ones digit
    result = angl.anglitime('10:50')
    introcs.assert_equals('ten hours, fifty minutes',result)

    # Two digit hour with no ones digit, two digit minute with no ones digit
    result = angl.anglitime('50:50')
    introcs.assert_equals('fifty hours, fifty minutes',result)

    # Proper two digit hour, two digit minute with no ones digit
    result = angl.anglitime('99:20')
    introcs.assert_equals('ninety nine hours, twenty minutes',result)

    # Plural ones digit hour, proper two digit minute
    result = angl.anglitime('5:63')
    introcs.assert_equals('five hours, sixty three minutes',result)

    # Singular ones digit hour, proper two digit minute
    result = angl.anglitime('1:45')
    introcs.assert_equals('one hour, forty five minutes',result)

    # Teens hour value, proper two digit minute
    result = angl.anglitime('14:59')
    introcs.assert_equals('fourteen hours, fifty nine minutes',result)

    # Two digit hour with no ones digit, proper two digit minute
    result = angl.anglitime('60:27')
    introcs.assert_equals('sixty hours, twenty seven minutes',result)

    # Proper two digit hour, proper two digit minute
    result = angl.anglitime('99:32')
    introcs.assert_equals('ninety nine hours, thirty two minutes',result)


if __name__ == '__main__':
    test_anglitime()
    print('Function anglitime passed all tests')
